package de.hft.stuttgart.citydoctor2.gui;

import java.util.Optional;

import de.hft.stuttgart.citydoctor2.check.Checker;
import de.hft.stuttgart.citydoctor2.datastructure.CityDoctorModel;
import javafx.scene.Node;
import javafx.scene.image.Image;
import javafx.scene.layout.HBox;

public abstract class View {
	
	private boolean firstTime = true;
	
	public abstract Optional<HBox> getToolbar();
	public abstract Node getMainScreen();
	public abstract Image getViewLogo();
	
	public abstract void initializeView(MainWindow mainWindow);
	
	public void fireOnShowEvent(CityDoctorModel model, Checker checker, MainWindow mainWindow) {
		if (firstTime) {
			firstTime = false;
			initializeView(mainWindow);
		}
		onShow(model, checker);
	}
	
	public abstract void onHide();
	public abstract void onShow(CityDoctorModel model, Checker checker);

}
